<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
/**
 * @package User.comForContactForm7
 */
/*
  Plugin Name: User.com for Contact Form 7
  Author URI: https://user.com/en-us/
  Author: UserEngage
  Description: User.com plugin for Contact Form 7 sends form submissions from Contact Form 7 to your User.com App.
  Version: 1.0.0
 */

/*  Copyright 2015-2018 UserEngage

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2, as
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 */

if( !function_exists("usercom_javascript") ) {
function usercom_javascript() {
	$api_key = get_option( 'UserEngageScript_apiKey' );
    $args = array('post_type' => 'wpcf7_contact_form', 'posts_per_page' => -1);
	$cf7Forms = get_posts( $args );
	$form_titles = wp_list_pluck( $cf7Forms , 'post_title' );
	$form_ids = wp_list_pluck( $cf7Forms , 'ID' );
    $form_titles_and_ids = wp_list_pluck( $cf7Forms , 'post_title', 'ID' );
	$form_titles = json_encode($form_titles);
	$form_ids =  json_encode($form_ids);
    $form_titles_and_ids = json_encode($form_titles_and_ids);
	$output = '<script type="text/javascript">';
	$output .=  "window.form_titles = JSON.parse( `$form_titles` );";
	$output .= "window.form_ids = JSON.parse( `$form_ids` );";
    $output .= "window.form_titles_and_ids = JSON.parse(`$form_titles_and_ids`);";
	$output .= "window.apiKey = `$api_key`;";
	$output .= 'jQuery(document).ready(()=>{jQuery(document).bind("wpcf7submit",e=>{let t=e.detail.inputs;if(jQuery(".wpcf7-form").hasClass("sent")){let i=e.detail.contactFormId;Object.entries(window.form_titles_and_ids).forEach(e=>{e[0]==i&&(window.contact_title=e[1])});let a=window.contact_title,n={};t.forEach(e=>{n[e.name]=e.value}),window.data_form=n,userengage("event."+a+" submitted",n),n.apiKey=window.apiKey,UE.pageHit(n)}})});';
    $output .= '</script>';
	echo $output;
}
add_action('wp_head', 'usercom_javascript');
}

add_action('admin_menu', 'usercomcf7_menu_setup');

function usercomcf7_menu_setup(){
    add_menu_page( 'User.com for contact form 7', 'user-com-cf7', 'manage_options', 'usercom-cf7', 'usercomcf7_menu' );
    add_action( 'admin_init', 'update_info_usercomcf7' );
}

if( !function_exists("update_info_usercomcf7") ) {
    function update_info_usercomcf7() {   register_setting( 'UserEngageScript__apiKey', 'UserEngageScript_apiKey' );
                               register_setting( 'UserEngageScript__apiKey', 'UserEngageScript_domain' ); } }

function usercom_style($hook) {
	if ( isset( $_GET['page'] ) == 'usercom-cf7' ) {
		wp_enqueue_style( 'usercomcf7_css', plugin_dir_url( __FILE__ ) . 'css/style.css');
	}
}
add_action( 'admin_enqueue_scripts', 'usercom_style' );

function usercomcf7_menu(){
    ?>
    <?php settings_errors(); ?>
    <div class="wrap ue_wrap">
        <h2> User.com Contact Form 7 - Options</h2>
        <hr/>
        <div class="ue container UserEngageScript__wrap">
            <form name="dofollow" action="options.php" method="post">

                <?php settings_fields( 'UserEngageScript__apiKey' ); ?>
                <?php do_settings_sections( 'UserEngageScript__apiKey' ); ?>
                <div class="ue row">
                    <div class="ue col">
                        <fieldset class="form-group">
                            <label for="apiKey">API Key</label>
                            <input type="text" id="apiKey"
                                   name="UserEngageScript_apiKey"
                                   class="ue input"
                                   placeholder="xxxxxx"
                                   value="<?php echo esc_html( get_option( 'UserEngageScript_apiKey' ) ); ?>"
                                   maxlength="128"
                                   required>
                        </fieldset>

                        <fieldset class="form-group">
                            <label for="domain">Subdomain</label>
                            <small>This field accepts domains in format eg.: subdomain.user.com (without https:// and following slash)</small>
                            <input type="text" id="domain"
                                   name="UserEngageScript_domain"
                                   class="ue input"
                                   placeholder="your_app_subdomain.user.com"
                                   value="<?php echo esc_html( get_option( 'UserEngageScript_domain' ) ); ?>">
                        </fieldset>
                        <p>Please enter your application key and subdomain. The API Key is a 6 letter and number string, you can find your API Key and domain click <a
                                    href="https://user.com/en/integrations/custom-script/"
                                    target="_blank">here</a></p>
                    </div>
                </div>
                <div class="ue row one">
                    <div class="ue col">
                        <input class="ue button info rounded block button-large"
                               type="submit" name="Submit" value="Save"/>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <?php
}

?>
